Agent = Core.class(Bitmap)

function Agent:init(region) -- create agent
  self.region = region
  self.position = {x = 0, y = 0}
  self.moving = false
  self.count = 0
  self.currentDir = 0
end

function Agent:setImage(r) -- set graphic
  local region = self.region
  region:setRegion(r[1], r[2], r[3], r[4])
  self:setTextureRegion(region)
end

function Agent:setLocation(x, y) -- set location in map
  local p = self.position
  p.x = x --* TILESIZE
  p.y = y --* TILESIZE
  self:setPosition(p.x, p.y)
end

function Agent:changeDirection(dir)
local floor = math.floor
  local cells = collisionMap
  local p = self.position
  local x = floor(p.x / TILESIZE) + 1
  local y = floor(p.y / TILESIZE) + 1
  local cell = cells[y][x]
  
  if not self.moving then
    if dir == 1 then -- l
      if cell.l then
        self.currentDir = dir
        self.moving = true
        self.count = 32
      end
    elseif dir == 2 then -- r
      if cell.r then
        self.currentDir = dir
        self.moving = true
        self.count = 32
      end
    elseif dir == 3 then -- u
      if cell.u then
        self.currentDir = dir
        self.moving = true
        self.count = 32
      end
    else -- d
      if cell.d then
        self.currentDir = dir
        self.moving = true
        self.count = 32
      end
    end
  end
end

function Agent:update()

  if self.moving then
    local count = self.count - 4
    local dir = self.currentDir
    local p = self.position

    if dir == 1 then -- left
      p.x = p.x - 4
    elseif dir == 2 then -- right
      p.x = p.x + 4
    elseif dir == 3 then -- up
      p.y = p.y - 4
    else -- down
      p.y = p.y + 4
    end

    self:setPosition(p.x, p.y)

    if count == 0 then
      self.moving = false
    end

    self.count = count
  end
end



